
///////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////// Packet Protocol:                                  ////////////////////////////
//////////////////////////// +------------+--------------+---------+-------+   ////////////////////////////
//////////////////////////// | Type | Data_Length | Data (X)(Y)(MSG) | CRC |   ////////////////////////////
//////////////////////////// +------------+--------------+---------+-------+   ////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "main.h"

void main(){
   int x=0;
   unsigned char chars[20];
   //initializing variables
   ext_buffer_next_in = 0;
   ext_buffer_next_out = 0;

   //initializing interrupts
   ext_int_edge(H_TO_L);
   enable_interrupts(INT_EXT);
   enable_interrupts(GLOBAL);

   while(TRUE)
   {
      if(MESSAGE_SEND)//*************************Send on push of button
      {
		 //Strcpy copies const char array to my character array
	     //this solves problems with CCS compiler
         strcpy(chars,"Hello there");
		 //function call formats calculates and sends packet
         lcd_write_chs_xy(0,0,chars);
         strcpy(chars,"This is your");
         lcd_write_chs_xy(0,1,chars);
         strcpy(chars,"computer speaking");
         lcd_write_chs_xy(0,2,chars);
         strcpy(chars,"to you VIA PIC16f877A");
         lcd_write_chs_xy(0,3,chars);
      }

      delay_ms(100);
      /*
      if(!DATA_IN)                        //in no data in
         continue;                        //loop back

      if(get_packet(packet_buffer))       //if valid packet
      {
         int16 length, i;
      */

   }
}//////////////////////////////////////////////////////////////////////////////////////////////////////////

void lcd_write_chs_xy(char x, char y,  unsigned char *ch){
   int z, data_loc;
   null_buffer();
   lcd_command(0x1f);
   data_loc = 3;
   while(*ch){
      data_loc++;
      lcd_write_character(*ch++, data_loc);
   }
   packet_buffer[1] = data_loc - 1;
   packet_buffer[2] = x;
   packet_buffer[3] = y;
   data_loc++;
   lcd_write_character(NULL, data_loc);
   send_packet(packet_buffer, get_length());  //sends the message
}//////////////////////////////////////////////////////////////////////////////////////////////////////////

void lcd_write_character(unsigned char c, int data_loc){
   packet_buffer[data_loc] = c;
}//////////////////////////////////////////////////////////////////////////////////////////////////////////

void lcd_command(unsigned char type){
   packet_buffer[0] = type;
}//////////////////////////////////////////////////////////////////////////////////////////////////////////

void null_buffer(){
   int x;
   packet_buffer[2] = NULL;
   for(x=3; x < BUFFER_SIZE; x++) packet_buffer[x] = 0x00;
}//////////////////////////////////////////////////////////////////////////////////////////////////////////

int16 get_length(){
   int x;
   int16 length = 0;
   for(x = 0; packet_buffer[x] != ''; x++) length++;
   return length;
}//////////////////////////////////////////////////////////////////////////////////////////////////////////




//External Interrupt
//Function for reading in bytes from other PIC's
#INT_EXT
void ext_isr()
{
   ext_buffer[ext_buffer_next_in] = getc();  //gets a byte, puts it in a buffer

   if(++ext_buffer_next_in == BUFFER_SIZE)   //increments counter
      ext_buffer_next_in = 0;
}//////////////////////////////////////////////////////////////////////////////////////////////////////////

//Get_buff_int
//Function to extract bytes from the buffer
int get_buff_int()
{
   int retval;

   while(!DATA_IN);                          //waits until the data becomes available

   retval = ext_buffer[ext_buffer_next_out]; //gets the byte
   if(++ext_buffer_next_out == BUFFER_SIZE)  //increments counter
      ext_buffer_next_out = 0;

      return retval;
}//////////////////////////////////////////////////////////////////////////////////////////////////////////

//Send_Packet
//function to send a packet of data to another PIC
void send_packet(int* packet_ptr, int16 packet_length)
{
   int *ptr;
   int16 CRC, i;

   ptr = packet_ptr;    //sets pointer

   CRC = get_crc(ptr, packet_length);
   //CRC = generate_16bit_crc(ptr, packet_length, 0x8408);    //make CRC from data, length, seed(bit_pattern?)(ML)

   for(i = 0;i < packet_length; i++)                           //sends this packet
      putc(packet_ptr[i]);

   putc((int)(CRC>>8));                                        //sends CRC
   putc((int)(CRC));
}//////////////////////////////////////////////////////////////////////////////////////////////////////////

/*
// GET_PACKET
// function to get a packet from the buffer and read the data
short get_packet(int* packet_ptr)
{
   short retval;
   int16 length;
   int16 CRC;
   int16 i;

   retval = TRUE;

   packet_ptr[0] = get_buff_int();              // get the address of send to
   packet_ptr[1] = get_buff_int();              // get the address of send from

   if(packet_ptr[0] != TYPE)                    //check for correct transmission string (ML)
      retval = FALSE;

   packet_ptr[2] = get_buff_int();              // get the control byte
   if(packet_ptr[2] == NACK)
      retval = FALSE;

   packet_ptr[3] = get_buff_int();              // get the length of the data
   packet_ptr[4] = get_buff_int();

   length = (int16)(packet_ptr[3])<<8;
   length += packet_ptr[4];

   for(i=5; i<(length+5); i++)                  // get the data
      packet_ptr[i] = get_buff_int();

   packet_ptr[length+5] = get_buff_int();       // get the CRC
   packet_ptr[length+6] = get_buff_int();

   CRC = (int16)(packet_ptr[length+5])<<8;
   CRC += packet_ptr[length+6];

   if(CRC != get_crc(packet_ptr, length+5))
      retval = FALSE;

   return retval;
}//////////////////////////////////////////////////////////////////////////////////////////////////////////

*/

