
///////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////// Packet Protocol:                                  ////////////////////////////
//////////////////////////// +------------+--------------+---------+-------+   ////////////////////////////
//////////////////////////// | Type | Data_Length | Data (X)(Y)(MSG) | CRC |   ////////////////////////////
//////////////////////////// +------------+--------------+---------+-------+   ////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////

#if defined(__PCM__)
#include <16F877A.H>
#device *=16
#fuses HS,NOWDT,NOPROTECT,NOLVP
#use delay(clock=20000000)
#use rs232 (baud=19200, xmit = PIN_C6, rcv = PIN_C7)

#elif defined(__PCH__)
#include <18F452.H>
#fuses HS,NOWDT,NOPROTECT,NOLVP
#use delay(clock=20000000)
#use rs232 (baud=19200, xmit = PIN_C6, rcv = PIN_C7)
#endif

#include "CRC_BSI.c"
#include <stdio.h>
#include <string.h>

#define NULL ''
#define FIRST_LED PIN_A5
#define SECOND_LED PIN_B4
#define THIRD_LED PIN_B5
#define PUSH_BUTTON PIN_A4

#define MESSAGE_SEND    (!input(PIN_A5))//***********************************************NEEDS TO BE FIXED
#define DATA_IN         (ext_buffer_next_in != ext_buffer_next_out)

//unsigned char TYPE = 0x1F;           //NEW(ML)*************************************************************
unsigned char DATA_LENGTH = 0x0f;
unsigned char NACK = 0xFF;

#define BUFFER_SIZE 24    //constant buffer size with a maximum of 25

int packet_buffer[BUFFER_SIZE];
//int *buff_ptr = packet_buffer[2];   //NEW(ML)*************************************************************
int ext_buffer[BUFFER_SIZE];
int ext_buffer_next_in;
int ext_buffer_next_out;



#INT_EXT
void ext_isr();
int get_buff_int();
void send_packet(int* packet_ptr, int16 packet_length);
short get_packet(int* packet_ptr);

void lcd_write_chs_xy(char x, char y, unsigned char ch[] );
void lcd_write_character(unsigned char c, int data_loc);
void lcd_command(unsigned char type);
void null_buffer();
int16 get_length();
